﻿using ProjetBlazor.Models;
using ProjetBlazor.Pages;
using Blazored.LocalStorage;
using Blazorise.DataGrid;
using Blazorise;
using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Text.Json;
using ProjetBlazor.Components;
using Microsoft.Extensions.Localization;
using ProjetBlazor.Models;

namespace ProjetBlazor.Components
{
    partial class Inventory
    {
        public Models.InventoryList inventory = new Models.InventoryList();
        public Models.InventoryItem CurrentDragItem { get; set; }
        public ObservableCollection<InventoryAction> Actions { get; set; }

        [Inject]
        internal IJSRuntime JavaScriptRuntime { get; set; }

        [Inject]
        public IStringLocalizer<InventoryList> Localizer { get; set; }


        [Inject]
        public ILocalStorageService LocalStorage { get; set; }
        
        [Inject]
        public HttpClient Http { get; set; }

        public Inventory() 
        {
            Actions = new ObservableCollection<InventoryAction>();
            Actions.CollectionChanged += OnActionsCollectionChanged;
        }


        private void OnActionsCollectionChanged(object? sender, NotifyCollectionChangedEventArgs e)
        {
            JavaScriptRuntime.InvokeVoidAsync("Crafting.AddActions", e.NewItems);
        }



        private async Task OnReadData(DataGridReadDataEventArgs<Item> e)
        {
            if (e.CancellationToken.IsCancellationRequested)
            {
                return;
            }

            var response = await LocalStorage.GetItemAsync<String>("list");

            if (!e.CancellationToken.IsCancellationRequested)
            {
                inventory = JsonSerializer.Deserialize<Models.InventoryList>(response);
            }
        }

    }
}
